config/routes.rb
Rails.application.routes.draw do
  scope '/api', format: :json do
    scope '/v1' do
      resources :companies do
        resources :offices
        resources :employees
        resources :projects
      end
    end
  end
  defaults format: :html do
    root 'home#index'
    get 'home/index'
    get '*path', to: 'home#index'
  end
end

app/models/employee.rb
class Employee < ApplicationRecord
  belongs_to :company
  belongs_to :office, optional: true
  has_many :employee_projects, dependent: :destroy
  has_many :projects, through: :employee_projects

  validates :name, presence: true, length: { maximum: 50 }
end

app/controllers/employees_controller.rb
class EmployeesController < ApplicationController
  before_action :set_employee, only: [:show, :edit, :update, :destroy]
  before_action :set_company, only: [:index, :new, :create]

  # GET /employees
  def index
    @employees = @company.employees
  end

  # GET /employees/1
  def show
  end

  # GET /employees/new
  def new
    @employee = @company.employees.new
  end

  # GET /employees/1/edit
  def edit
  end

  # POST /employees
  def create
    @employee = @company.employees.new(employee_params)

    if @employee.save
      redirect_to company_employee_url(@employee.company, @employee), notice: t('notice.created')
    else
      render :new
    end
  end

  # PATCH/PUT /employees/1
  def update
    if @employee.update(employee_params)
      redirect_to company_employee_url(@employee.company, @employee), notice: t('notice.updated')
    else
      render :edit
    end
  end

  # DELETE /employees/1
  def destroy
    @employee.destroy
    redirect_to company_employees_url, notice: t('notice.destroyed')
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_employee
      @employee = Company.find(params[:company_id]).employees.find(params[:id])
    end

    def set_company
      @company = Company.find(params[:company_id])
    end

    # Only allow a list of trusted parameters through.
    def employee_params
      params.require(:employee).permit(:office_id, :number, :name)
    end
end

app/views/employees/_form.html.erb
<%= form_with(model: [company, employee]) do |form| %>
  <% if employee.errors.any? %>
    <div id="error_explanation">
      <h2><%= t('errors.template.header.other', model: t('activerecord.models.employee'), count: employee.errors.count) %></h2>

      <ul>
        <% employee.errors.each do |error| %>
          <li><%= error.full_message %></li>
        <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= form.label 'company.name' %>
    <%= company.name %>
  </div>

  <div class="field">
    <%= form.label 'office.name' %>
    <%= form.collection_select :office_id, company.offices, :id, :name, include_blank: true %>
  </div>

  <div class="field">
    <%= form.label :number %>
    <%= form.text_field :number %>
  </div>

  <div class="field">
    <%= form.label :name %>
    <%= form.text_field :name %>
  </div>

  <div class="actions">
    <%= form.submit %>
  </div>
<% end %>

app/views/employees/edit.html.erb
<% breadcrumb :edit_employee, @employee %>

<h1><%= t('.') %></h1>

<%= render 'form', company: @employee.company, employee: @employee %>

<%= link_to t('show'), company_employee_path(@employee.company, @employee) %> |
<%= link_to t('back'), company_employees_path(@employee.company) %>

app/views/employees/index.html.erb
<% breadcrumb :employees, @company %>

<p id="notice"><%= notice %></p>

<h1><%= t('.') %></h1>

<table>
  <thead>
    <tr>
      <th><%= t('activerecord.models.company') %><%= t('activerecord.attributes.company.name') %></th>
      <th><%= t('activerecord.models.office') %><%= t('activerecord.attributes.office.name') %></th>
      <th><%= t('activerecord.attributes.employee.number') %></th>
      <th><%= t('activerecord.attributes.employee.name') %></th>
      <th colspan="3"></th>
    </tr>
  </thead>

  <tbody>
    <% @employees.each do |employee| %>
      <tr>
        <td><%= employee.company.name %></td>
        <td><%= employee.office&.name || '-' %></td>
        <td><%= employee.number %></td>
        <td><%= employee.name %></td>
        <td><%= link_to t('show'), company_employee_path(employee.company, employee) %></td>
        <td><%= link_to t('edit'), edit_company_employee_path(employee.company, employee) %></td>
        <td><%= link_to t('destroy'), company_employee_path(employee.company, employee), method: :delete, data: { confirm: t('confirm') } %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<br>

<%= link_to t('employees.new'), new_company_employee_path(@company) %>

app/views/employees/new.html.erb
<% breadcrumb :new_office, @employee.company %>

<h1><%= t('.') %></h1>

<%= render 'form', company: @employee.company, employee: @employee %>

<%= link_to t('back'), company_employees_path(@employee.company) %>

app/views/employees/show.html.erb
<% breadcrumb :employee, @employee %>

<p id="notice"><%= notice %></p>

<p>
  <strong><%= t('activerecord.attributes.company.name') %>:</strong>
  <%= @employee.company.name %>
</p>

<p>
  <strong><%= t('activerecord.attributes.office.name') %>:</strong>
  <%= @employee.office&.name || '-' %>
</p>

<p>
  <strong><%= t('activerecord.attributes.employee.number') %>:</strong>
  <%= @employee.number %>
</p>

<p>
  <strong><%= t('activerecord.attributes.employee.name') %>:</strong>
  <%= @employee.name %>
</p>

<%= link_to t('edit'), edit_company_employee_path(@employee.company, @employee) %> |
<%= link_to t('back'), company_employees_path(@employee.company) %>